<?php

namespace App|C\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Buy ServiceType
 * @subpackage Services
 */
class Buy extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named BuyServices
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \App|C\StructType\BuyServices $parameters
     * @return \App|C\StructType\BuyServicesResponse|bool
     */
    public function BuyServices(\App|C\StructType\BuyServices $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->BuyServices($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \App|C\StructType\BuyServicesResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
