<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExchangeResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ExchangeResponse
 * @subpackage Structs
 */
class ExchangeResponse extends AbstractResponse
{
    /**
     * The ExchangeResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ExchangeResponse
     */
    public $ExchangeResult;
    /**
     * The Booking
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Booking
     */
    public $Booking;
    /**
     * The InvalidData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\InvalidDataErrors
     */
    public $InvalidData;
    /**
     * Constructor method for ExchangeResponse
     * @uses ExchangeResponse::setExchangeResult()
     * @uses ExchangeResponse::setBooking()
     * @uses ExchangeResponse::setInvalidData()
     * @param \App|C\StructType\ExchangeResponse $exchangeResult
     * @param \App|C\StructType\Booking $booking
     * @param \App|C\StructType\InvalidDataErrors $invalidData
     */
    public function __construct(\App|C\StructType\ExchangeResponse $exchangeResult = null, \App|C\StructType\Booking $booking = null, \App|C\StructType\InvalidDataErrors $invalidData = null)
    {
        $this
            ->setExchangeResult($exchangeResult)
            ->setBooking($booking)
            ->setInvalidData($invalidData);
    }
    /**
     * Get ExchangeResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ExchangeResponse|null
     */
    public function getExchangeResult()
    {
        return isset($this->ExchangeResult) ? $this->ExchangeResult : null;
    }
    /**
     * Set ExchangeResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\ExchangeResponse $exchangeResult
     * @return \App|C\StructType\ExchangeResponse
     */
    public function setExchangeResult(\App|C\StructType\ExchangeResponse $exchangeResult = null)
    {
        if (is_null($exchangeResult) || (is_array($exchangeResult) && empty($exchangeResult))) {
            unset($this->ExchangeResult);
        } else {
            $this->ExchangeResult = $exchangeResult;
        }
        return $this;
    }
    /**
     * Get Booking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Booking|null
     */
    public function getBooking()
    {
        return isset($this->Booking) ? $this->Booking : null;
    }
    /**
     * Set Booking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Booking $booking
     * @return \App|C\StructType\ExchangeResponse
     */
    public function setBooking(\App|C\StructType\Booking $booking = null)
    {
        if (is_null($booking) || (is_array($booking) && empty($booking))) {
            unset($this->Booking);
        } else {
            $this->Booking = $booking;
        }
        return $this;
    }
    /**
     * Get InvalidData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\InvalidDataErrors|null
     */
    public function getInvalidData()
    {
        return isset($this->InvalidData) ? $this->InvalidData : null;
    }
    /**
     * Set InvalidData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\InvalidDataErrors $invalidData
     * @return \App|C\StructType\ExchangeResponse
     */
    public function setInvalidData(\App|C\StructType\InvalidDataErrors $invalidData = null)
    {
        if (is_null($invalidData) || (is_array($invalidData) && empty($invalidData))) {
            unset($this->InvalidData);
        } else {
            $this->InvalidData = $invalidData;
        }
        return $this;
    }
}
