<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FareInfo
 * @subpackage Structs
 */
class FareInfo extends FareInfoBase
{
    /**
     * The SaleCurrencyCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SaleCurrencyCode;
    /**
     * Constructor method for FareInfo
     * @uses FareInfo::setSaleCurrencyCode()
     * @param string $saleCurrencyCode
     */
    public function __construct($saleCurrencyCode = null)
    {
        $this
            ->setSaleCurrencyCode($saleCurrencyCode);
    }
    /**
     * Get SaleCurrencyCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSaleCurrencyCode()
    {
        return isset($this->SaleCurrencyCode) ? $this->SaleCurrencyCode : null;
    }
    /**
     * Set SaleCurrencyCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $saleCurrencyCode
     * @return \App|C\StructType\FareInfo
     */
    public function setSaleCurrencyCode($saleCurrencyCode = null)
    {
        // validation for constraint: string
        if (!is_null($saleCurrencyCode) && !is_string($saleCurrencyCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($saleCurrencyCode, true), gettype($saleCurrencyCode)), __LINE__);
        }
        if (is_null($saleCurrencyCode) || (is_array($saleCurrencyCode) && empty($saleCurrencyCode))) {
            unset($this->SaleCurrencyCode);
        } else {
            $this->SaleCurrencyCode = $saleCurrencyCode;
        }
        return $this;
    }
}
