<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FlightStatusResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FlightStatusResponse
 * @subpackage Structs
 */
class FlightStatusResponse extends AbstractResponse
{
    /**
     * The FlightStatusResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FlightStatusResponse
     */
    public $FlightStatusResult;
    /**
     * The FlightSummaries
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfFlightStatusSummary
     */
    public $FlightSummaries;
    /**
     * Constructor method for FlightStatusResponse
     * @uses FlightStatusResponse::setFlightStatusResult()
     * @uses FlightStatusResponse::setFlightSummaries()
     * @param \App|C\StructType\FlightStatusResponse $flightStatusResult
     * @param \App|C\ArrayType\ArrayOfFlightStatusSummary $flightSummaries
     */
    public function __construct(\App|C\StructType\FlightStatusResponse $flightStatusResult = null, \App|C\ArrayType\ArrayOfFlightStatusSummary $flightSummaries = null)
    {
        $this
            ->setFlightStatusResult($flightStatusResult)
            ->setFlightSummaries($flightSummaries);
    }
    /**
     * Get FlightStatusResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FlightStatusResponse|null
     */
    public function getFlightStatusResult()
    {
        return isset($this->FlightStatusResult) ? $this->FlightStatusResult : null;
    }
    /**
     * Set FlightStatusResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FlightStatusResponse $flightStatusResult
     * @return \App|C\StructType\FlightStatusResponse
     */
    public function setFlightStatusResult(\App|C\StructType\FlightStatusResponse $flightStatusResult = null)
    {
        if (is_null($flightStatusResult) || (is_array($flightStatusResult) && empty($flightStatusResult))) {
            unset($this->FlightStatusResult);
        } else {
            $this->FlightStatusResult = $flightStatusResult;
        }
        return $this;
    }
    /**
     * Get FlightSummaries value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfFlightStatusSummary|null
     */
    public function getFlightSummaries()
    {
        return isset($this->FlightSummaries) ? $this->FlightSummaries : null;
    }
    /**
     * Set FlightSummaries value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfFlightStatusSummary $flightSummaries
     * @return \App|C\StructType\FlightStatusResponse
     */
    public function setFlightSummaries(\App|C\ArrayType\ArrayOfFlightStatusSummary $flightSummaries = null)
    {
        if (is_null($flightSummaries) || (is_array($flightSummaries) && empty($flightSummaries))) {
            unset($this->FlightSummaries);
        } else {
            $this->FlightSummaries = $flightSummaries;
        }
        return $this;
    }
}
