<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SegmentSold StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SegmentSold
 * @subpackage Structs
 */
class SegmentSold extends Segment
{
    /**
     * The ArrivalElement
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ArrivalElement;
    /**
     * The BookingClassCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BookingClassCode;
    /**
     * The CabinClassCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CabinClassCode;
    /**
     * The ContinuationElements
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfstring_1
     */
    public $ContinuationElements;
    /**
     * The OperatingBookingClassCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OperatingBookingClassCode;
    /**
     * The OperatingPnrCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OperatingPnrCode;
    /**
     * The PnrCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PnrCode;
    /**
     * Constructor method for SegmentSold
     * @uses SegmentSold::setArrivalElement()
     * @uses SegmentSold::setBookingClassCode()
     * @uses SegmentSold::setCabinClassCode()
     * @uses SegmentSold::setContinuationElements()
     * @uses SegmentSold::setOperatingBookingClassCode()
     * @uses SegmentSold::setOperatingPnrCode()
     * @uses SegmentSold::setPnrCode()
     * @param string $arrivalElement
     * @param string $bookingClassCode
     * @param string $cabinClassCode
     * @param \App|C\ArrayType\ArrayOfstring_1 $continuationElements
     * @param string $operatingBookingClassCode
     * @param string $operatingPnrCode
     * @param string $pnrCode
     */
    public function __construct($arrivalElement = null, $bookingClassCode = null, $cabinClassCode = null, \App|C\ArrayType\ArrayOfstring_1 $continuationElements = null, $operatingBookingClassCode = null, $operatingPnrCode = null, $pnrCode = null)
    {
        $this
            ->setArrivalElement($arrivalElement)
            ->setBookingClassCode($bookingClassCode)
            ->setCabinClassCode($cabinClassCode)
            ->setContinuationElements($continuationElements)
            ->setOperatingBookingClassCode($operatingBookingClassCode)
            ->setOperatingPnrCode($operatingPnrCode)
            ->setPnrCode($pnrCode);
    }
    /**
     * Get ArrivalElement value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getArrivalElement()
    {
        return isset($this->ArrivalElement) ? $this->ArrivalElement : null;
    }
    /**
     * Set ArrivalElement value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $arrivalElement
     * @return \App|C\StructType\SegmentSold
     */
    public function setArrivalElement($arrivalElement = null)
    {
        // validation for constraint: string
        if (!is_null($arrivalElement) && !is_string($arrivalElement)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($arrivalElement, true), gettype($arrivalElement)), __LINE__);
        }
        if (is_null($arrivalElement) || (is_array($arrivalElement) && empty($arrivalElement))) {
            unset($this->ArrivalElement);
        } else {
            $this->ArrivalElement = $arrivalElement;
        }
        return $this;
    }
    /**
     * Get BookingClassCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBookingClassCode()
    {
        return isset($this->BookingClassCode) ? $this->BookingClassCode : null;
    }
    /**
     * Set BookingClassCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bookingClassCode
     * @return \App|C\StructType\SegmentSold
     */
    public function setBookingClassCode($bookingClassCode = null)
    {
        // validation for constraint: string
        if (!is_null($bookingClassCode) && !is_string($bookingClassCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bookingClassCode, true), gettype($bookingClassCode)), __LINE__);
        }
        if (is_null($bookingClassCode) || (is_array($bookingClassCode) && empty($bookingClassCode))) {
            unset($this->BookingClassCode);
        } else {
            $this->BookingClassCode = $bookingClassCode;
        }
        return $this;
    }
    /**
     * Get CabinClassCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCabinClassCode()
    {
        return isset($this->CabinClassCode) ? $this->CabinClassCode : null;
    }
    /**
     * Set CabinClassCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cabinClassCode
     * @return \App|C\StructType\SegmentSold
     */
    public function setCabinClassCode($cabinClassCode = null)
    {
        // validation for constraint: string
        if (!is_null($cabinClassCode) && !is_string($cabinClassCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cabinClassCode, true), gettype($cabinClassCode)), __LINE__);
        }
        if (is_null($cabinClassCode) || (is_array($cabinClassCode) && empty($cabinClassCode))) {
            unset($this->CabinClassCode);
        } else {
            $this->CabinClassCode = $cabinClassCode;
        }
        return $this;
    }
    /**
     * Get ContinuationElements value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfstring_1|null
     */
    public function getContinuationElements()
    {
        return isset($this->ContinuationElements) ? $this->ContinuationElements : null;
    }
    /**
     * Set ContinuationElements value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfstring_1 $continuationElements
     * @return \App|C\StructType\SegmentSold
     */
    public function setContinuationElements(\App|C\ArrayType\ArrayOfstring_1 $continuationElements = null)
    {
        if (is_null($continuationElements) || (is_array($continuationElements) && empty($continuationElements))) {
            unset($this->ContinuationElements);
        } else {
            $this->ContinuationElements = $continuationElements;
        }
        return $this;
    }
    /**
     * Get OperatingBookingClassCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOperatingBookingClassCode()
    {
        return isset($this->OperatingBookingClassCode) ? $this->OperatingBookingClassCode : null;
    }
    /**
     * Set OperatingBookingClassCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $operatingBookingClassCode
     * @return \App|C\StructType\SegmentSold
     */
    public function setOperatingBookingClassCode($operatingBookingClassCode = null)
    {
        // validation for constraint: string
        if (!is_null($operatingBookingClassCode) && !is_string($operatingBookingClassCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($operatingBookingClassCode, true), gettype($operatingBookingClassCode)), __LINE__);
        }
        if (is_null($operatingBookingClassCode) || (is_array($operatingBookingClassCode) && empty($operatingBookingClassCode))) {
            unset($this->OperatingBookingClassCode);
        } else {
            $this->OperatingBookingClassCode = $operatingBookingClassCode;
        }
        return $this;
    }
    /**
     * Get OperatingPnrCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOperatingPnrCode()
    {
        return isset($this->OperatingPnrCode) ? $this->OperatingPnrCode : null;
    }
    /**
     * Set OperatingPnrCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $operatingPnrCode
     * @return \App|C\StructType\SegmentSold
     */
    public function setOperatingPnrCode($operatingPnrCode = null)
    {
        // validation for constraint: string
        if (!is_null($operatingPnrCode) && !is_string($operatingPnrCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($operatingPnrCode, true), gettype($operatingPnrCode)), __LINE__);
        }
        if (is_null($operatingPnrCode) || (is_array($operatingPnrCode) && empty($operatingPnrCode))) {
            unset($this->OperatingPnrCode);
        } else {
            $this->OperatingPnrCode = $operatingPnrCode;
        }
        return $this;
    }
    /**
     * Get PnrCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPnrCode()
    {
        return isset($this->PnrCode) ? $this->PnrCode : null;
    }
    /**
     * Set PnrCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pnrCode
     * @return \App|C\StructType\SegmentSold
     */
    public function setPnrCode($pnrCode = null)
    {
        // validation for constraint: string
        if (!is_null($pnrCode) && !is_string($pnrCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pnrCode, true), gettype($pnrCode)), __LINE__);
        }
        if (is_null($pnrCode) || (is_array($pnrCode) && empty($pnrCode))) {
            unset($this->PnrCode);
        } else {
            $this->PnrCode = $pnrCode;
        }
        return $this;
    }
}
